use strict;
use URI::URL;
use File::Temp qw/ tempfile tempdir /;
use File::Copy;

my $WGET_COMMAND = "wget --user-agent=Mozilla --tries=inf --max-redirect=0";
  # '--quiet' and '--output-file' if downloading. 
  # '--spider' if checking existance

sub available {
    my $url = shift;
    my $header = `$WGET_COMMAND --spider \"$url\" 2>&1 | grep \"200 OK\"`;
    return $header;
}

sub get_html {
    my $url = shift;

    print " getting: \"$url\"\n";
    my $html = `$WGET_COMMAND --quiet --output-document=-  \"$url\"`; 
    
    return $html;
}

sub parse {
    my $html = shift;
    my $regex = shift;
    my $caught_path = "";
    

    $html =~ /$regex/si;
    $caught_path = $1;

    $caught_path =~ s/\n//g; #clean it


    print " parsed: \"$caught_path\"";
    print " | using regex: \"$regex\"";    
    print "\n";

    $regex = "";
    $html = "";

    return $caught_path;
}

sub download_comic {

    my $url = shift;
    my $save_path = shift; #without extension

    print " getting: \"$url\"\n";


    my $temp_dir = tempdir( CLEANUP => 1 );
    my ($fh, $temp_file) = tempfile( DIR => $temp_dir );
    
    my $out_file;
    # Apparently the only place that we have to worry about wget continuting
    # after being killed
    my $code = system("$WGET_COMMAND --quiet --no-cache --output-document=\"$temp_file\" \"$url\"");
    if ($code == 0) {
        my $pic_details = `identify $temp_file`;
        $pic_details =~ /$temp_file.*?([A-Z]+) \d+x\d+ /m;
        my $ext = lc $1;
        $out_file = "$save_path.$ext";
        copy($temp_file,$out_file) or die "Copying downloaded file failed: $!";
        print " saved: \"$out_file\"\n";
    } else {
        print "Wget experienced an error: [$code].\n  See the wget manual about the problem.\n";
        exit 1;
    }
    return $out_file;
}
1;
