#!/usr/bin/perl

sub read_file {
    my $in_file = shift;

    open(FILE, "<$in_file") || die "Could not open $in_file: $!";
    my @lines = <FILE>;
    $first_line = @lines[0];
    $first_line =~ s/\n//g;

    return $first_line;
}

sub read_conf {
    my $in_file = shift;

    my %comic_list;
    open(my $in,  "<", $in_file ) || die "Could not open $in_file: $!";
    
    my $comic = "";
    while ( <$in> ) {
        # skip comments
        if ($_ =~ /^#/) { next } 
        
        # grab headers
        elsif ($_ =~ /^([a-zA-Z0-9_]+?):\s*$/) {
            $comic = $1;
        }
        elsif ($_ =~ /^\s+([a-zA-Z0-9_]+?)="(.*)"\s*$/) {
            my $key = $1;
            my $value = $2;
            $comic_list{$comic}{$key} = $value;
        }
        else { next }
    }
    return %comic_list;
}
1;
